# class for centralizing Creative's logging logic
class ChiliLogger
  # module responsible for uniformization of values in ChiliLogger
  module Values
    # class for keeping all default values in a single place
    class Default
      def msg_broker
        :rabbitmq
      end

      def fallback_broker
        :aws_sqs
      end

      def user
        {
          cognito_id: undefined_string,
          email: undefined_string,
          company_cognito_id: undefined_string,
          company_name: undefined_string,
          ghost_user_cognito_id: undefined_string
        }
      end

      def env
        undefined_string
      end

      def layer
        undefined_string
      end

      def type
        undefined_string
      end

      def service
        undefined_string
      end

      def action
        undefined_string
      end

      def desc
        { type: type, service: service, action: action }
      end

      def main_content
        { modified_records: modified_records, errors: log_errors }
      end

      def modified_records
        {}
      end

      def log_errors
        []
      end

      def log_error
        sentence1 = 'ChiliLogger received an unsupported type of error, so it replaced it with this generic string.'
        sentence2 = ' Errors must be either a String or a descendant of the Exception class.'
        sentence1 + sentence2
      end

      def server_url
        undefined_string
      end

      def log
        {}
      end

      def sqs_message
        {
          error_type: undefined_string,
          error_message: undefined_string,
          log: undefined_string
        }
      end

      def invalid_string
        'invalid_format'
      end

      def undefined_string
        'not_specified'
      end
    end
  end
end
