require 'helpers/values/secrets/aws_secrets_manager'

# class for centralizing Creative's logging logic
class ChiliLogger
  # module responsible for uniformization of values in ChiliLogger
  module Values
    # class to centralize access to all secrets stored in 3rd-party managers
    class Secrets
      def initialize(manager_name = 'aws')
        manager_class = supported_managers[manager_name.to_s]
        manager_class ||= supported_managers['aws']

        @secrets_manager = manager_class.new
      end

      def get_secrets_collection(collection_name)
        @secrets_manager.get_secrets_collection(collection_name)
      end

      private

      def supported_managers
        {
          'aws' => AwsSecretsManager
        }
      end
    end
  end
end
